/*Rasterized polygon class-- a class to encapsulated a screen-rasterized polygon.*/
public class Rastergon{
	int xMin,xMax,yMin,yMax;
	public Span spans[];
	public Span spanY;
	public Rastergon(int screenWidth,int screenHeight,int borderWidth)
	{
		int i;
		yMin=xMin=borderWidth;
		xMax=screenWidth-borderWidth;
		yMax=screenHeight-borderWidth;
		spans=new Span[screenHeight];
		/*Set max less than min-- this is a non-existent span.*/
		for (i=0;i<screenHeight;i++)
			{spans[i]=new Span();spans[i].min=xMax;spans[i].max=xMin;}
		spanY=new Span();
	}
	public void addLine(Line3D line)
	{
		Vector bottom=line.pos,top=line.pos.plus(line.dir);
		if (bottom.y==top.y)
			return;/*Nothing to do for a horizontal line.*/
		else if (bottom.y>top.y)
			{Vector temp=bottom;bottom=top;top=temp;}/*Swap top and bottom*/
		double slope=(bottom.x-top.x)/(bottom.y-top.y);
		double intercept=bottom.x-bottom.y*slope;
		int bottomy=(int)Math.ceil(bottom.y),topy=(int)Math.ceil(top.y);
		if (bottomy<yMin) bottomy=yMin;
		if (bottomy>yMax) bottomy=yMax;
		spanY.addPoint(bottomy);
		if (topy<yMin) topy=yMin;
		if (topy>yMax) topy=yMax;
		spanY.addPoint(topy);
		int y;
		for (y=bottomy;y<topy;y++)
		{
			int x=(int)Math.ceil(slope*y+intercept);
			if (x<xMin) x=xMin;
			if (x>xMax) x=xMax;
			spans[y].addPoint(x);
		}
	}
}
