/* Java Source File 
a part of SliceViewer
  a program written in 2/98 by Orion Lawlor.
Public domain source code.

Send questions to fsosl@uaf.edu
*/
import java.awt.*;

public class Ruler extends Indicator
{
	int getIndicatorPos()
		{ return centerY+(int)(value*scale); }
	public void setIndicatorPos(int y)
		{ value=(y-centerY)/scale; }
	//Draw ruler (-1cm, 0cm, 1cm, etc).
	void drawPriv(Graphics g)
	{
		g.setColor(Color.white);
		int dist;//Distance from zero, in mm.
		int minMM=(int)((bounds.y-centerY)/scale);
		int maxMM=(int)((bounds.y+bounds.height-centerY)/scale);
		int endX=bounds.x+bounds.width;
		for (dist=minMM;dist<maxMM;dist++)
		{
			int yPos=(int)(scale*dist)+centerY;
			if (dist%10==0)
			{	//A centimeter marking-- draw larger, with a caption
				g.drawLine(bounds.x+10,yPos,endX,yPos);
				g.drawString(Integer.toString(dist/10)+"cm",bounds.x,yPos-2);
			}
			else //Just a millimeter marking-- draw smaller
				g.drawLine(endX-10,yPos,endX,yPos);
		}
	}
};
