#!/bin/sh
#

if [ $# -lt 1 ]
then
	echo "Usage: stack.sh <image files...>"
	echo " Assembles arbitrary-format images into a "
	echo " single 3D brick of bytes, suitable for use"
	echo " with SliceViewer."
	echo " Requires the ImageMagick program 'convert'"
	echo " Orion Sky Lawlor, olawlor@acm.org, 2003/4/1"
	exit 1
fi

out="stack.dat"
rm $out
nImages="0"

while [ $# -ne 0 ]
do
	in="$1"
	shift
	echo "Converting image $in..."
	convert "$in" gray:temp.raw || exit 1
# 	ls -al temp.raw
	cat temp.raw >> $out
	nImages=`expr $nImages + 1`
done

echo "$nImages image planes stacked into $out"
